#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	ofEnableAlphaBlending();
	ofBackground(255, 255, 255);

	
	for (int i = 0; i < 12; i++){
		particle myParticle1;
		particle myParticle2;
		particle myParticle3;
		
		myParticle1.setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
		myParticle2.setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
		myParticle3.setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
		
		particles1.push_back(myParticle1);
		particles2.push_back(myParticle2);
		particles3.push_back(myParticle3);
	}
	
	bRepel		= true;
	radius		= 40;
	strength	= 0.5f; 
	
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	for (int i = 0; i < particles1.size(); i++){
		particles1[i].resetForce();
		particles2[i].resetForce();
		particles3[i].resetForce();
	}
	
	
	// zach's way !!!!
	for (int i = 0; i < particles1.size(); i++){
		for (int j = 0; j < i; j++){
				particles1[i].addAttractionForce(particles1[j], 400, strength);
				particles1[i].addRepulsionForce(particles1[j], 90, 5.0f);
				
				particles2[i].addAttractionForce(particles2[j], 400, strength);
				particles2[i].addRepulsionForce(particles2[j], 90, 5.0f);
				
				particles3[i].addAttractionForce(particles3[j], 400, strength);
				particles3[i].addRepulsionForce(particles3[j], 90, 5.0f);

				particles1[i].addRepulsionForce(particles2[j], 600, 0.9f);
				particles2[i].addRepulsionForce(particles3[j], 500, 0.5f);
				particles3[i].addRepulsionForce(particles1[j], 400, 1.5f);

		}
	}
	
	for (int i = 0; i < particles1.size(); i++){
		particles1[i].addDampingForce();
		particles2[i].addDampingForce();
		particles3[i].addDampingForce();
		
		particles1[i].update();
		particles2[i].update();
		particles3[i].update();
		
		particles1[i].bounceOffWalls();
		particles2[i].bounceOffWalls();
		particles3[i].bounceOffWalls();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
//	ofEnableAlphaBlending();
//	ofSetColor(0,130,130, 200);
//	
//	ofSetColor(0x000000);
	
	for (int i = 0; i < particles1.size(); i++){
		particles1[i].draw(1);
		particles2[i].draw(2);
		particles3[i].draw(3);
	}
	
//	string reportString =	"(space) = reset\n(a/s) strength = " + ofToString(strength) + 
//							"\n(z/x) radius = " + ofToString(radius) + 
//							"\n(r) toggle mode = " + (bRepel ? "repelling" : "attracting");
//	
//	ofSetColor(40,40,0);
//	ofRect(10,10,300,80);
//	ofSetColor(255,255,255);
//	ofDrawBitmapString(reportString, 30, 30);
	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles1.size(); i++){
				particles1[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
				particles2[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
				particles3[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
		case 'a':
			strength += 0.02f;
			break;
		case 's':
			strength -= 0.02f;
			if (strength <= 0) strength = 0.02f;
			break;
		case 'z':
			radius += 5.0f;
			break;
		case 'x':
			radius -= 5.0f;
			if (radius <= 0) radius = 5.0f;
			break;
		case 'r':
			bRepel = !bRepel;
			break;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	particles1.erase(particles1.begin());
	particle myParticle1;
	myParticle1.setInitialCondition(x,y,0,0);
	particles1.push_back(myParticle1);
	
	particles2.erase(particles2.begin());
	particle myParticle2;
	myParticle2.setInitialCondition(x,y,0,0);
	particles2.push_back(myParticle2);
	
	particles3.erase(particles3.begin());
	particle myParticle3;
	myParticle3.setInitialCondition(x,y,0,0);
	particles3.push_back(myParticle3);
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
